// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'wclAudio.pas' rev: 6.00

#ifndef wclAudioHPP
#define wclAudioHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Windows.hpp>	// Pascal unit
#include <wclMessaging.hpp>	// Pascal unit
#include <wclWinAPI.hpp>	// Pascal unit
#include <wclAudioApi.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Wclaudio
{
//-- type declarations -------------------------------------------------------
#pragma option push -b
enum TwclAudioDeviceDataFlow { dfRender, dfCapture };
#pragma option pop

#pragma option push -b
enum TwclAudioDeviceRole { drConsole, drMultimedia, drCommunications };
#pragma option pop

typedef Set<TwclAudioDeviceRole, drConsole, drCommunications>  TwclAudioDeviceRoles;

#pragma option push -b
enum TwclAudioDeviceState { asActive, asDisabled, asNotPresent, asUnplugged };
#pragma option pop

typedef Set<TwclAudioDeviceState, asActive, asUnplugged>  TwclAudioDeviceStates;

#pragma option push -b
enum TwclAudioHardwareFeature { hfVolume, hfMute, hfMeter };
#pragma option pop

typedef Set<TwclAudioHardwareFeature, hfVolume, hfMeter>  TwclAudioHardwareFeatures;

struct TwclAudioDevice
{
	AnsiString Id;
	AnsiString FriendlyName;
	AnsiString Description;
	TwclAudioDeviceDataFlow Flow;
	TwclAudioDeviceRoles Roles;
	TwclAudioDeviceState State;
	bool IsBluetooth;
	__int64 Mac;
	GUID Service;
} ;

typedef DynamicArray<TwclAudioDevice >  TwclAudioDevices;

typedef DynamicArray<float >  TwclAudioPeakValues;

typedef void __fastcall (__closure *TwclAudioDefaultDeviceChangedEvent)(System::TObject* Sender, const AnsiString Id, const TwclAudioDeviceDataFlow Flow, const TwclAudioDeviceRole Role);

typedef void __fastcall (__closure *TwclAudioDeviceEvent)(System::TObject* Sender, const AnsiString Id);

typedef void __fastcall (__closure *TwclAudioDeviceStateChangedEvent)(System::TObject* Sender, const AnsiString Id, const TwclAudioDeviceState State);

typedef void __fastcall (__closure *TwclAudioVolumeChangedEvent)(System::TObject* Sender, const bool Muted, const float Volume, const TwclAudioPeakValues Volumes);

class DELPHICLASS TwclCustomAudio;
class PASCALIMPLEMENTATION TwclCustomAudio : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Wclaudioapi::_di_IMMDeviceEnumerator FEnumerator;
	Wclaudioapi::_di_IMMNotificationClient FEventHandler;
	Wclmessaging::TwclMessageReceiver* FReceiver;
	Classes::TNotifyEvent FOnClosed;
	Classes::TNotifyEvent FOnOpened;
	bool __fastcall GetActive(void);
	
protected:
	virtual int __fastcall InternalClose(void);
	virtual int __fastcall InternalOpen(void);
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual void __fastcall DoClosed(void);
	virtual void __fastcall DoOpened(void);
	virtual int __fastcall Open(void);
	__property Wclaudioapi::_di_IMMDeviceEnumerator Enumerator = {read=FEnumerator};
	__property Wclmessaging::TwclMessageReceiver* Receiver = {read=FReceiver};
	
public:
	__fastcall virtual TwclCustomAudio(Classes::TComponent* AOwner);
	__fastcall virtual ~TwclCustomAudio(void);
	virtual int __fastcall Close(void);
	__property bool Active = {read=GetActive, nodefault};
	
__published:
	__property Classes::TNotifyEvent OnClosed = {read=FOnClosed, write=FOnClosed};
	__property Classes::TNotifyEvent OnOpened = {read=FOnOpened, write=FOnOpened};
};


class DELPHICLASS TwclCustomAudioEndpoint;
class PASCALIMPLEMENTATION TwclCustomAudioEndpoint : public TwclCustomAudio 
{
	typedef TwclCustomAudio inherited;
	
private:
	AnsiString FId;
	Classes::TNotifyEvent FOnDisconnected;
	
protected:
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual void __fastcall DoDisconnected(void);
	
public:
	__fastcall virtual TwclCustomAudioEndpoint(Classes::TComponent* AOwner);
	virtual int __fastcall Close(void);
	HIDESBASE int __fastcall Open(const AnsiString Id);
	virtual int __fastcall GetChannels(/* out */ unsigned &Count) = 0 ;
	virtual int __fastcall GetHardwareFeatures(/* out */ TwclAudioHardwareFeatures &Features) = 0 ;
	__property AnsiString Id = {read=FId};
	
__published:
	__property Classes::TNotifyEvent OnDisconnected = {read=FOnDisconnected, write=FOnDisconnected};
public:
	#pragma option push -w-inl
	/* TwclCustomAudio.Destroy */ inline __fastcall virtual ~TwclCustomAudioEndpoint(void) { }
	#pragma option pop
	
};


class DELPHICLASS TwclAudioSwitcher;
class PASCALIMPLEMENTATION TwclAudioSwitcher : public TwclCustomAudio 
{
	typedef TwclCustomAudio inherited;
	
private:
	TwclAudioDefaultDeviceChangedEvent FOnDefaultDeviceChanged;
	TwclAudioDeviceEvent FOnDeviceAdded;
	TwclAudioDeviceEvent FOnDeviceRemoved;
	TwclAudioDeviceStateChangedEvent FOnStateChanged;
	void __fastcall GetBluetoothDetails(TwclAudioDevice &Device);
	bool __fastcall GetDeviceProps(const Wclaudioapi::_di_IMMDevice MMDevice, /* out */ TwclAudioDevice &Device);
	TwclAudioDeviceRoles __fastcall GetRoles(const Wclaudioapi::EDataFlow Flow, const AnsiString Id);
	int __fastcall EnumDevices(const TwclAudioDeviceStates States, TwclAudioDevices &Devices);
	int __fastcall CheckDeviceState(const AnsiString Id, const bool Connect);
	int __fastcall ChangeDeviceState(const AnsiString Id, const bool Connect);
	
protected:
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual void __fastcall DoDefaultDeviceChanged(const AnsiString Id, const TwclAudioDeviceDataFlow Flow, const TwclAudioDeviceRole Role);
	virtual void __fastcall DoDeviceAdded(const AnsiString Id);
	virtual void __fastcall DoDeviceRemoved(const AnsiString Id);
	virtual void __fastcall DoStateChanged(const AnsiString Id, const TwclAudioDeviceState State);
	
public:
	__fastcall virtual TwclAudioSwitcher(Classes::TComponent* AOwner);
	virtual int __fastcall Open(void);
	int __fastcall Enum(const TwclAudioDeviceStates States, /* out */ TwclAudioDevices &Devices);
	int __fastcall GetDeviceDetails(const AnsiString Id, /* out */ TwclAudioDevice &Device);
	int __fastcall GetDefault(const TwclAudioDeviceRole Role, const TwclAudioDeviceDataFlow Flow, /* out */ AnsiString &Id);
	int __fastcall SetDefault(const TwclAudioDeviceRole Role, const AnsiString Id);
	int __fastcall Connect(const AnsiString Id)/* overload */;
	int __fastcall Connect(const __int64 Address)/* overload */;
	int __fastcall Disconnect(const AnsiString Id)/* overload */;
	int __fastcall Disconnect(const __int64 Address)/* overload */;
	
__published:
	__property TwclAudioDefaultDeviceChangedEvent OnDefaultDeviceChanged = {read=FOnDefaultDeviceChanged, write=FOnDefaultDeviceChanged};
	__property TwclAudioDeviceEvent OnDeviceAdded = {read=FOnDeviceAdded, write=FOnDeviceAdded};
	__property TwclAudioDeviceEvent OnDeviceRemoved = {read=FOnDeviceRemoved, write=FOnDeviceRemoved};
	__property TwclAudioDeviceStateChangedEvent OnStateChanged = {read=FOnStateChanged, write=FOnStateChanged};
public:
	#pragma option push -w-inl
	/* TwclCustomAudio.Destroy */ inline __fastcall virtual ~TwclAudioSwitcher(void) { }
	#pragma option pop
	
};


class DELPHICLASS TwclAudioMeter;
class PASCALIMPLEMENTATION TwclAudioMeter : public TwclCustomAudioEndpoint 
{
	typedef TwclCustomAudioEndpoint inherited;
	
private:
	Wclaudioapi::_di_IAudioMeterInformation FMeter;
	
protected:
	virtual int __fastcall InternalClose(void);
	virtual int __fastcall InternalOpen(void);
	
public:
	__fastcall virtual TwclAudioMeter(Classes::TComponent* AOwner);
	virtual int __fastcall GetChannels(/* out */ unsigned &Count);
	int __fastcall GetChannelsPeak(/* out */ TwclAudioPeakValues &Values);
	virtual int __fastcall GetHardwareFeatures(/* out */ TwclAudioHardwareFeatures &Features);
	int __fastcall GetPeak(/* out */ float &Value);
public:
	#pragma option push -w-inl
	/* TwclCustomAudio.Destroy */ inline __fastcall virtual ~TwclAudioMeter(void) { }
	#pragma option pop
	
};


class DELPHICLASS TwclAudioVolume;
class PASCALIMPLEMENTATION TwclAudioVolume : public TwclCustomAudioEndpoint 
{
	typedef TwclCustomAudioEndpoint inherited;
	
private:
	#pragma pack(push, 1)
	GUID FContext;
	#pragma pack(pop)
	
	Wclaudioapi::_di_IAudioEndpointVolume FVolume;
	Wclaudioapi::_di_IAudioEndpointVolumeCallback FVolumeCallback;
	TwclAudioVolumeChangedEvent FOnChanged;
	
protected:
	virtual void __fastcall MessageReceived(const Wclmessaging::TwclMessage* Message);
	virtual int __fastcall InternalClose(void);
	virtual int __fastcall InternalOpen(void);
	virtual void __fastcall DoChanged(const bool Muted, const float Volume, const TwclAudioPeakValues Volumes);
	
public:
	__fastcall virtual TwclAudioVolume(Classes::TComponent* AOwner);
	virtual int __fastcall GetChannels(/* out */ unsigned &Count);
	virtual int __fastcall GetHardwareFeatures(/* out */ TwclAudioHardwareFeatures &Features);
	int __fastcall GetChannelVolume(const unsigned Channel, /* out */ float &Volume);
	int __fastcall GetMute(/* out */ bool &Mute);
	int __fastcall GetVolume(/* out */ float &Volume);
	int __fastcall SetChannelVolume(const unsigned Channel, const float Value);
	int __fastcall SetMute(const bool Mute);
	int __fastcall SetVolume(const float Value);
	
__published:
	__property TwclAudioVolumeChangedEvent OnChanged = {read=FOnChanged, write=FOnChanged};
public:
	#pragma option push -w-inl
	/* TwclCustomAudio.Destroy */ inline __fastcall virtual ~TwclAudioVolume(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Wclaudio */
using namespace Wclaudio;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// wclAudio
